'
' Serial Communication test program
' using read GPS-data (clock time from GPS)
'
' Program: gps-test.bas
'
' 2017-08-04 Peter Svard
'
Cls
Cursor 0,0
Print "gps-test.bas"
'
Open "COM7: baud=9600 data=8 parity=n stop=1 rts=off dtr=off octs=off idsr=off" As #1
'
' main-loop start
'
Do
' read in one GPS-message line
x$=""
Do
d$=Input$(1,#1)
x$=x$+d$
Loop Until d$=Chr$(10)
'
' check if $GPGGA -message
' if...then, take out UTC-time (and calculate local time)
'
If Instr(1,x$,"$GPGGA") Then
    hh$=Mid$(x$,8,2)
    mm$=Mid$(x$,10,2)
    ss$=Mid$(x$,12,2)
    ' only print complete time data
    If hh$<>"" And mm$<>"" And ss$<>"" Then
        Cursor 0,2
        Print "  UTC Time = ";hh$;".";mm$;".";ss$
        h=Val(hh$) ' h = UTC time
        z=2 ' z = local time diff.
        aa$=Str$(h+z) ' calculate local time
        Cursor 0,3
        Print "Local Time = ";aa$;".";mm$;".";ss$
    EndIf
EndIf
'
' check if $GPRMC -message
' if...then, take out Date
'
If Instr(1,x$,"$GPRMC") Then
'Print x$
' Take out Date from message
sp=0 ' zero string position counter
count=0 ' zero loop counter
Do
c=Instr(sp+1,x$,",")
If c Then
    'Print c;",";
    sp=c
EndIf
count=count+1
' check if loop is looping to long time...
If count>10 Then
    'Print "Date is not in message...corrupt-data?"
    Exit loop
EndIf
Loop Until count=9 ' end loop when 9 comma is found
' Print date in raw format ddmmyy
Cursor 30,2
Print "Date (ddmmyy) = ";Mid$(x$,sp+1,6)
' Print date in yymmdd
Cursor 30,3
Print "Date (yymmdd) = ";
Print Mid$(x$,sp+5,2);
Print Mid$(x$,sp+3,2);
Print Mid$(x$,sp+1,2)
EndIf
'
Print
Loop ' main-loop end
'
Close #1 ' close serial communication

